<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Do ServiceType
 * @subpackage Services
 */
class _Do extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named doXferAnfrage
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DoXferAnfrage $parameters
     * @return \StructType\DoXferAnfrageResponse|bool
     */
    public function doXferAnfrage(\StructType\DoXferAnfrage $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->doXferAnfrage($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named doSearch11
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DoSearch11 $parameters
     * @return \StructType\DoSearch11Response|bool
     */
    public function doSearch11(\StructType\DoSearch11 $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->doSearch11($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named doSearch20
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DoSearch20 $parameters
     * @return \StructType\DoSearch20Response|bool
     */
    public function doSearch20(\StructType\DoSearch20 $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->doSearch20($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named doXferIn
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DoXferIn $parameters
     * @return \StructType\DoXferInResponse|bool
     */
    public function doXferIn(\StructType\DoXferIn $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->doXferIn($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named doXferReservierung
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DoXferReservierung $parameters
     * @return \StructType\DoXferReservierungResponse|bool
     */
    public function doXferReservierung(\StructType\DoXferReservierung $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->doXferReservierung($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\DoSearch11Response|\StructType\DoSearch20Response|\StructType\DoXferAnfrageResponse|\StructType\DoXferInResponse|\StructType\DoXferReservierungResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
