<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for anreden StructType
 * @subpackage Structs
 */
class Anreden extends AbstractStructBase
{
    /**
     * The anrede
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Anrede[]
     */
    public $anrede;
    /**
     * Constructor method for anreden
     * @uses Anreden::setAnrede()
     * @param \StructType\Anrede[] $anrede
     */
    public function __construct(array $anrede = array())
    {
        $this
            ->setAnrede($anrede);
    }
    /**
     * Get anrede value
     * @return \StructType\Anrede[]|null
     */
    public function getAnrede()
    {
        return $this->anrede;
    }
    /**
     * This method is responsible for validating the values passed to the setAnrede method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnrede method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnredeForArrayConstraintsFromSetAnrede(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $anredenAnredeItem) {
            // validation for constraint: itemType
            if (!$anredenAnredeItem instanceof \StructType\Anrede) {
                $invalidValues[] = is_object($anredenAnredeItem) ? get_class($anredenAnredeItem) : sprintf('%s(%s)', gettype($anredenAnredeItem), var_export($anredenAnredeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The anrede property can only contain items of type \StructType\Anrede, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set anrede value
     * @throws \InvalidArgumentException
     * @param \StructType\Anrede[] $anrede
     * @return \StructType\Anreden
     */
    public function setAnrede(array $anrede = array())
    {
        // validation for constraint: array
        if ('' !== ($anredeArrayErrorMessage = self::validateAnredeForArrayConstraintsFromSetAnrede($anrede))) {
            throw new \InvalidArgumentException($anredeArrayErrorMessage, __LINE__);
        }
        $this->anrede = $anrede;
        return $this;
    }
    /**
     * Add item to anrede value
     * @throws \InvalidArgumentException
     * @param \StructType\Anrede $item
     * @return \StructType\Anreden
     */
    public function addToAnrede(\StructType\Anrede $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Anrede) {
            throw new \InvalidArgumentException(sprintf('The anrede property can only contain items of type \StructType\Anrede, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->anrede[] = $item;
        return $this;
    }
}
