<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for belegungskalenderdata StructType
 * @subpackage Structs
 */
class Belegungskalenderdata extends AbstractStructBase
{
    /**
     * The belegungen
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Belegungskalenderdatapos[]
     */
    public $belegungen;
    /**
     * The meldungen
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $meldungen;
    /**
     * Constructor method for belegungskalenderdata
     * @uses Belegungskalenderdata::setBelegungen()
     * @uses Belegungskalenderdata::setMeldungen()
     * @param \StructType\Belegungskalenderdatapos[] $belegungen
     * @param string[] $meldungen
     */
    public function __construct(array $belegungen = array(), array $meldungen = array())
    {
        $this
            ->setBelegungen($belegungen)
            ->setMeldungen($meldungen);
    }
    /**
     * Get belegungen value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Belegungskalenderdatapos[]|null
     */
    public function getBelegungen()
    {
        return isset($this->belegungen) ? $this->belegungen : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBelegungen method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBelegungen method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBelegungenForArrayConstraintsFromSetBelegungen(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $belegungskalenderdataBelegungenItem) {
            // validation for constraint: itemType
            if (!$belegungskalenderdataBelegungenItem instanceof \StructType\Belegungskalenderdatapos) {
                $invalidValues[] = is_object($belegungskalenderdataBelegungenItem) ? get_class($belegungskalenderdataBelegungenItem) : sprintf('%s(%s)', gettype($belegungskalenderdataBelegungenItem), var_export($belegungskalenderdataBelegungenItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The belegungen property can only contain items of type \StructType\Belegungskalenderdatapos, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set belegungen value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Belegungskalenderdatapos[] $belegungen
     * @return \StructType\Belegungskalenderdata
     */
    public function setBelegungen(array $belegungen = array())
    {
        // validation for constraint: array
        if ('' !== ($belegungenArrayErrorMessage = self::validateBelegungenForArrayConstraintsFromSetBelegungen($belegungen))) {
            throw new \InvalidArgumentException($belegungenArrayErrorMessage, __LINE__);
        }
        if (is_null($belegungen) || (is_array($belegungen) && empty($belegungen))) {
            unset($this->belegungen);
        } else {
            $this->belegungen = $belegungen;
        }
        return $this;
    }
    /**
     * Add item to belegungen value
     * @throws \InvalidArgumentException
     * @param \StructType\Belegungskalenderdatapos $item
     * @return \StructType\Belegungskalenderdata
     */
    public function addToBelegungen(\StructType\Belegungskalenderdatapos $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Belegungskalenderdatapos) {
            throw new \InvalidArgumentException(sprintf('The belegungen property can only contain items of type \StructType\Belegungskalenderdatapos, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->belegungen[] = $item;
        return $this;
    }
    /**
     * Get meldungen value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getMeldungen()
    {
        return isset($this->meldungen) ? $this->meldungen : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMeldungen method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMeldungen method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMeldungenForArrayConstraintsFromSetMeldungen(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $belegungskalenderdataMeldungenItem) {
            // validation for constraint: itemType
            if (!is_string($belegungskalenderdataMeldungenItem)) {
                $invalidValues[] = is_object($belegungskalenderdataMeldungenItem) ? get_class($belegungskalenderdataMeldungenItem) : sprintf('%s(%s)', gettype($belegungskalenderdataMeldungenItem), var_export($belegungskalenderdataMeldungenItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The meldungen property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set meldungen value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $meldungen
     * @return \StructType\Belegungskalenderdata
     */
    public function setMeldungen(array $meldungen = array())
    {
        // validation for constraint: array
        if ('' !== ($meldungenArrayErrorMessage = self::validateMeldungenForArrayConstraintsFromSetMeldungen($meldungen))) {
            throw new \InvalidArgumentException($meldungenArrayErrorMessage, __LINE__);
        }
        if (is_null($meldungen) || (is_array($meldungen) && empty($meldungen))) {
            unset($this->meldungen);
        } else {
            $this->meldungen = $meldungen;
        }
        return $this;
    }
    /**
     * Add item to meldungen value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\Belegungskalenderdata
     */
    public function addToMeldungen($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The meldungen property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->meldungen[] = $item;
        return $this;
    }
}
