<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for belegungskalenderrequest StructType
 * @subpackage Structs
 */
class Belegungskalenderrequest extends AbstractStructBase
{
    /**
     * The hausid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $hausid;
    /**
     * The katid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $katid;
    /**
     * The channelid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $channelid;
    /**
     * The von
     * @var string
     */
    public $von;
    /**
     * The bis
     * @var string
     */
    public $bis;
    /**
     * Constructor method for belegungskalenderrequest
     * @uses Belegungskalenderrequest::setHausid()
     * @uses Belegungskalenderrequest::setKatid()
     * @uses Belegungskalenderrequest::setChannelid()
     * @uses Belegungskalenderrequest::setVon()
     * @uses Belegungskalenderrequest::setBis()
     * @param int[] $hausid
     * @param int[] $katid
     * @param int[] $channelid
     * @param string $von
     * @param string $bis
     */
    public function __construct(array $hausid = array(), array $katid = array(), array $channelid = array(), $von = null, $bis = null)
    {
        $this
            ->setHausid($hausid)
            ->setKatid($katid)
            ->setChannelid($channelid)
            ->setVon($von)
            ->setBis($bis);
    }
    /**
     * Get hausid value
     * @return int[]|null
     */
    public function getHausid()
    {
        return $this->hausid;
    }
    /**
     * This method is responsible for validating the values passed to the setHausid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHausid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHausidForArrayConstraintsFromSetHausid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $belegungskalenderrequestHausidItem) {
            // validation for constraint: itemType
            if (!(is_int($belegungskalenderrequestHausidItem) || ctype_digit($belegungskalenderrequestHausidItem))) {
                $invalidValues[] = is_object($belegungskalenderrequestHausidItem) ? get_class($belegungskalenderrequestHausidItem) : sprintf('%s(%s)', gettype($belegungskalenderrequestHausidItem), var_export($belegungskalenderrequestHausidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hausid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hausid value
     * @throws \InvalidArgumentException
     * @param int[] $hausid
     * @return \StructType\Belegungskalenderrequest
     */
    public function setHausid(array $hausid = array())
    {
        // validation for constraint: array
        if ('' !== ($hausidArrayErrorMessage = self::validateHausidForArrayConstraintsFromSetHausid($hausid))) {
            throw new \InvalidArgumentException($hausidArrayErrorMessage, __LINE__);
        }
        $this->hausid = $hausid;
        return $this;
    }
    /**
     * Add item to hausid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Belegungskalenderrequest
     */
    public function addToHausid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The hausid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hausid[] = $item;
        return $this;
    }
    /**
     * Get katid value
     * @return int[]|null
     */
    public function getKatid()
    {
        return $this->katid;
    }
    /**
     * This method is responsible for validating the values passed to the setKatid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKatid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKatidForArrayConstraintsFromSetKatid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $belegungskalenderrequestKatidItem) {
            // validation for constraint: itemType
            if (!(is_int($belegungskalenderrequestKatidItem) || ctype_digit($belegungskalenderrequestKatidItem))) {
                $invalidValues[] = is_object($belegungskalenderrequestKatidItem) ? get_class($belegungskalenderrequestKatidItem) : sprintf('%s(%s)', gettype($belegungskalenderrequestKatidItem), var_export($belegungskalenderrequestKatidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The katid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set katid value
     * @throws \InvalidArgumentException
     * @param int[] $katid
     * @return \StructType\Belegungskalenderrequest
     */
    public function setKatid(array $katid = array())
    {
        // validation for constraint: array
        if ('' !== ($katidArrayErrorMessage = self::validateKatidForArrayConstraintsFromSetKatid($katid))) {
            throw new \InvalidArgumentException($katidArrayErrorMessage, __LINE__);
        }
        $this->katid = $katid;
        return $this;
    }
    /**
     * Add item to katid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Belegungskalenderrequest
     */
    public function addToKatid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The katid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->katid[] = $item;
        return $this;
    }
    /**
     * Get channelid value
     * @return int[]|null
     */
    public function getChannelid()
    {
        return $this->channelid;
    }
    /**
     * This method is responsible for validating the values passed to the setChannelid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChannelid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChannelidForArrayConstraintsFromSetChannelid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $belegungskalenderrequestChannelidItem) {
            // validation for constraint: itemType
            if (!(is_int($belegungskalenderrequestChannelidItem) || ctype_digit($belegungskalenderrequestChannelidItem))) {
                $invalidValues[] = is_object($belegungskalenderrequestChannelidItem) ? get_class($belegungskalenderrequestChannelidItem) : sprintf('%s(%s)', gettype($belegungskalenderrequestChannelidItem), var_export($belegungskalenderrequestChannelidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The channelid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set channelid value
     * @throws \InvalidArgumentException
     * @param int[] $channelid
     * @return \StructType\Belegungskalenderrequest
     */
    public function setChannelid(array $channelid = array())
    {
        // validation for constraint: array
        if ('' !== ($channelidArrayErrorMessage = self::validateChannelidForArrayConstraintsFromSetChannelid($channelid))) {
            throw new \InvalidArgumentException($channelidArrayErrorMessage, __LINE__);
        }
        $this->channelid = $channelid;
        return $this;
    }
    /**
     * Add item to channelid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Belegungskalenderrequest
     */
    public function addToChannelid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The channelid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->channelid[] = $item;
        return $this;
    }
    /**
     * Get von value
     * @return string|null
     */
    public function getVon()
    {
        return $this->von;
    }
    /**
     * Set von value
     * @param string $von
     * @return \StructType\Belegungskalenderrequest
     */
    public function setVon($von = null)
    {
        // validation for constraint: string
        if (!is_null($von) && !is_string($von)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($von, true), gettype($von)), __LINE__);
        }
        $this->von = $von;
        return $this;
    }
    /**
     * Get bis value
     * @return string|null
     */
    public function getBis()
    {
        return $this->bis;
    }
    /**
     * Set bis value
     * @param string $bis
     * @return \StructType\Belegungskalenderrequest
     */
    public function setBis($bis = null)
    {
        // validation for constraint: string
        if (!is_null($bis) && !is_string($bis)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bis, true), gettype($bis)), __LINE__);
        }
        $this->bis = $bis;
        return $this;
    }
}
