<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bezirk StructType
 * @subpackage Structs
 */
class Bezirk extends AbstractStructBase
{
    /**
     * The ortid
     * @var int
     */
    public $ortid;
    /**
     * The bezirkid
     * @var int
     */
    public $bezirkid;
    /**
     * The status
     * @var int
     */
    public $status;
    /**
     * The bezeichnung
     * @var string
     */
    public $bezeichnung;
    /**
     * The lastchange
     * @var string
     */
    public $lastchange;
    /**
     * The anzunterkuenfte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $anzunterkuenfte;
    /**
     * Constructor method for bezirk
     * @uses Bezirk::setOrtid()
     * @uses Bezirk::setBezirkid()
     * @uses Bezirk::setStatus()
     * @uses Bezirk::setBezeichnung()
     * @uses Bezirk::setLastchange()
     * @uses Bezirk::setAnzunterkuenfte()
     * @param int $ortid
     * @param int $bezirkid
     * @param int $status
     * @param string $bezeichnung
     * @param string $lastchange
     * @param int $anzunterkuenfte
     */
    public function __construct($ortid = null, $bezirkid = null, $status = null, $bezeichnung = null, $lastchange = null, $anzunterkuenfte = null)
    {
        $this
            ->setOrtid($ortid)
            ->setBezirkid($bezirkid)
            ->setStatus($status)
            ->setBezeichnung($bezeichnung)
            ->setLastchange($lastchange)
            ->setAnzunterkuenfte($anzunterkuenfte);
    }
    /**
     * Get ortid value
     * @return int|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * Set ortid value
     * @param int $ortid
     * @return \StructType\Bezirk
     */
    public function setOrtid($ortid = null)
    {
        // validation for constraint: int
        if (!is_null($ortid) && !(is_int($ortid) || ctype_digit($ortid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ortid, true), gettype($ortid)), __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Get bezirkid value
     * @return int|null
     */
    public function getBezirkid()
    {
        return $this->bezirkid;
    }
    /**
     * Set bezirkid value
     * @param int $bezirkid
     * @return \StructType\Bezirk
     */
    public function setBezirkid($bezirkid = null)
    {
        // validation for constraint: int
        if (!is_null($bezirkid) && !(is_int($bezirkid) || ctype_digit($bezirkid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bezirkid, true), gettype($bezirkid)), __LINE__);
        }
        $this->bezirkid = $bezirkid;
        return $this;
    }
    /**
     * Get status value
     * @return int|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param int $status
     * @return \StructType\Bezirk
     */
    public function setStatus($status = null)
    {
        // validation for constraint: int
        if (!is_null($status) && !(is_int($status) || ctype_digit($status))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get bezeichnung value
     * @return string|null
     */
    public function getBezeichnung()
    {
        return $this->bezeichnung;
    }
    /**
     * Set bezeichnung value
     * @param string $bezeichnung
     * @return \StructType\Bezirk
     */
    public function setBezeichnung($bezeichnung = null)
    {
        // validation for constraint: string
        if (!is_null($bezeichnung) && !is_string($bezeichnung)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bezeichnung, true), gettype($bezeichnung)), __LINE__);
        }
        $this->bezeichnung = $bezeichnung;
        return $this;
    }
    /**
     * Get lastchange value
     * @return string|null
     */
    public function getLastchange()
    {
        return $this->lastchange;
    }
    /**
     * Set lastchange value
     * @param string $lastchange
     * @return \StructType\Bezirk
     */
    public function setLastchange($lastchange = null)
    {
        // validation for constraint: string
        if (!is_null($lastchange) && !is_string($lastchange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastchange, true), gettype($lastchange)), __LINE__);
        }
        $this->lastchange = $lastchange;
        return $this;
    }
    /**
     * Get anzunterkuenfte value
     * @return int|null
     */
    public function getAnzunterkuenfte()
    {
        return $this->anzunterkuenfte;
    }
    /**
     * Set anzunterkuenfte value
     * @param int $anzunterkuenfte
     * @return \StructType\Bezirk
     */
    public function setAnzunterkuenfte($anzunterkuenfte = null)
    {
        // validation for constraint: int
        if (!is_null($anzunterkuenfte) && !(is_int($anzunterkuenfte) || ctype_digit($anzunterkuenfte))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($anzunterkuenfte, true), gettype($anzunterkuenfte)), __LINE__);
        }
        $this->anzunterkuenfte = $anzunterkuenfte;
        return $this;
    }
}
