<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bezirke StructType
 * @subpackage Structs
 */
class Bezirke extends AbstractStructBase
{
    /**
     * The bezirk
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Bezirk[]
     */
    public $bezirk;
    /**
     * Constructor method for bezirke
     * @uses Bezirke::setBezirk()
     * @param \StructType\Bezirk[] $bezirk
     */
    public function __construct(array $bezirk = array())
    {
        $this
            ->setBezirk($bezirk);
    }
    /**
     * Get bezirk value
     * @return \StructType\Bezirk[]|null
     */
    public function getBezirk()
    {
        return $this->bezirk;
    }
    /**
     * This method is responsible for validating the values passed to the setBezirk method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBezirk method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBezirkForArrayConstraintsFromSetBezirk(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bezirkeBezirkItem) {
            // validation for constraint: itemType
            if (!$bezirkeBezirkItem instanceof \StructType\Bezirk) {
                $invalidValues[] = is_object($bezirkeBezirkItem) ? get_class($bezirkeBezirkItem) : sprintf('%s(%s)', gettype($bezirkeBezirkItem), var_export($bezirkeBezirkItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bezirk property can only contain items of type \StructType\Bezirk, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bezirk value
     * @throws \InvalidArgumentException
     * @param \StructType\Bezirk[] $bezirk
     * @return \StructType\Bezirke
     */
    public function setBezirk(array $bezirk = array())
    {
        // validation for constraint: array
        if ('' !== ($bezirkArrayErrorMessage = self::validateBezirkForArrayConstraintsFromSetBezirk($bezirk))) {
            throw new \InvalidArgumentException($bezirkArrayErrorMessage, __LINE__);
        }
        $this->bezirk = $bezirk;
        return $this;
    }
    /**
     * Add item to bezirk value
     * @throws \InvalidArgumentException
     * @param \StructType\Bezirk $item
     * @return \StructType\Bezirke
     */
    public function addToBezirk(\StructType\Bezirk $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Bezirk) {
            throw new \InvalidArgumentException(sprintf('The bezirk property can only contain items of type \StructType\Bezirk, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bezirk[] = $item;
        return $this;
    }
}
