<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bildklassen StructType
 * @subpackage Structs
 */
class Bildklassen extends AbstractStructBase
{
    /**
     * The bildklasse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Bildklasse[]
     */
    public $bildklasse;
    /**
     * Constructor method for bildklassen
     * @uses Bildklassen::setBildklasse()
     * @param \StructType\Bildklasse[] $bildklasse
     */
    public function __construct(array $bildklasse = array())
    {
        $this
            ->setBildklasse($bildklasse);
    }
    /**
     * Get bildklasse value
     * @return \StructType\Bildklasse[]|null
     */
    public function getBildklasse()
    {
        return $this->bildklasse;
    }
    /**
     * This method is responsible for validating the values passed to the setBildklasse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBildklasse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBildklasseForArrayConstraintsFromSetBildklasse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bildklassenBildklasseItem) {
            // validation for constraint: itemType
            if (!$bildklassenBildklasseItem instanceof \StructType\Bildklasse) {
                $invalidValues[] = is_object($bildklassenBildklasseItem) ? get_class($bildklassenBildklasseItem) : sprintf('%s(%s)', gettype($bildklassenBildklasseItem), var_export($bildklassenBildklasseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bildklasse property can only contain items of type \StructType\Bildklasse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bildklasse value
     * @throws \InvalidArgumentException
     * @param \StructType\Bildklasse[] $bildklasse
     * @return \StructType\Bildklassen
     */
    public function setBildklasse(array $bildklasse = array())
    {
        // validation for constraint: array
        if ('' !== ($bildklasseArrayErrorMessage = self::validateBildklasseForArrayConstraintsFromSetBildklasse($bildklasse))) {
            throw new \InvalidArgumentException($bildklasseArrayErrorMessage, __LINE__);
        }
        $this->bildklasse = $bildklasse;
        return $this;
    }
    /**
     * Add item to bildklasse value
     * @throws \InvalidArgumentException
     * @param \StructType\Bildklasse $item
     * @return \StructType\Bildklassen
     */
    public function addToBildklasse(\StructType\Bildklasse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Bildklasse) {
            throw new \InvalidArgumentException(sprintf('The bildklasse property can only contain items of type \StructType\Bildklasse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bildklasse[] = $item;
        return $this;
    }
}
