<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changesdata StructType
 * @subpackage Structs
 */
class Changesdata extends AbstractStructBase
{
    /**
     * The changespos
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Changesdatapos[]
     */
    public $changespos;
    /**
     * Constructor method for changesdata
     * @uses Changesdata::setChangespos()
     * @param \StructType\Changesdatapos[] $changespos
     */
    public function __construct(array $changespos = array())
    {
        $this
            ->setChangespos($changespos);
    }
    /**
     * Get changespos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Changesdatapos[]|null
     */
    public function getChangespos()
    {
        return isset($this->changespos) ? $this->changespos : null;
    }
    /**
     * This method is responsible for validating the values passed to the setChangespos method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangespos method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangesposForArrayConstraintsFromSetChangespos(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $changesdataChangesposItem) {
            // validation for constraint: itemType
            if (!$changesdataChangesposItem instanceof \StructType\Changesdatapos) {
                $invalidValues[] = is_object($changesdataChangesposItem) ? get_class($changesdataChangesposItem) : sprintf('%s(%s)', gettype($changesdataChangesposItem), var_export($changesdataChangesposItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The changespos property can only contain items of type \StructType\Changesdatapos, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set changespos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Changesdatapos[] $changespos
     * @return \StructType\Changesdata
     */
    public function setChangespos(array $changespos = array())
    {
        // validation for constraint: array
        if ('' !== ($changesposArrayErrorMessage = self::validateChangesposForArrayConstraintsFromSetChangespos($changespos))) {
            throw new \InvalidArgumentException($changesposArrayErrorMessage, __LINE__);
        }
        if (is_null($changespos) || (is_array($changespos) && empty($changespos))) {
            unset($this->changespos);
        } else {
            $this->changespos = $changespos;
        }
        return $this;
    }
    /**
     * Add item to changespos value
     * @throws \InvalidArgumentException
     * @param \StructType\Changesdatapos $item
     * @return \StructType\Changesdata
     */
    public function addToChangespos(\StructType\Changesdatapos $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Changesdatapos) {
            throw new \InvalidArgumentException(sprintf('The changespos property can only contain items of type \StructType\Changesdatapos, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->changespos[] = $item;
        return $this;
    }
}
