<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changesdatapos StructType
 * @subpackage Structs
 */
class Changesdatapos extends AbstractStructBase
{
    /**
     * The typ
     * @var string
     */
    public $typ;
    /**
     * The changesposone
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Changesdataposone[]
     */
    public $changesposone;
    /**
     * Constructor method for changesdatapos
     * @uses Changesdatapos::setTyp()
     * @uses Changesdatapos::setChangesposone()
     * @param string $typ
     * @param \StructType\Changesdataposone[] $changesposone
     */
    public function __construct($typ = null, array $changesposone = array())
    {
        $this
            ->setTyp($typ)
            ->setChangesposone($changesposone);
    }
    /**
     * Get typ value
     * @return string|null
     */
    public function getTyp()
    {
        return $this->typ;
    }
    /**
     * Set typ value
     * @param string $typ
     * @return \StructType\Changesdatapos
     */
    public function setTyp($typ = null)
    {
        // validation for constraint: string
        if (!is_null($typ) && !is_string($typ)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typ, true), gettype($typ)), __LINE__);
        }
        $this->typ = $typ;
        return $this;
    }
    /**
     * Get changesposone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Changesdataposone[]|null
     */
    public function getChangesposone()
    {
        return isset($this->changesposone) ? $this->changesposone : null;
    }
    /**
     * This method is responsible for validating the values passed to the setChangesposone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangesposone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangesposoneForArrayConstraintsFromSetChangesposone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $changesdataposChangesposoneItem) {
            // validation for constraint: itemType
            if (!$changesdataposChangesposoneItem instanceof \StructType\Changesdataposone) {
                $invalidValues[] = is_object($changesdataposChangesposoneItem) ? get_class($changesdataposChangesposoneItem) : sprintf('%s(%s)', gettype($changesdataposChangesposoneItem), var_export($changesdataposChangesposoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The changesposone property can only contain items of type \StructType\Changesdataposone, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set changesposone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Changesdataposone[] $changesposone
     * @return \StructType\Changesdatapos
     */
    public function setChangesposone(array $changesposone = array())
    {
        // validation for constraint: array
        if ('' !== ($changesposoneArrayErrorMessage = self::validateChangesposoneForArrayConstraintsFromSetChangesposone($changesposone))) {
            throw new \InvalidArgumentException($changesposoneArrayErrorMessage, __LINE__);
        }
        if (is_null($changesposone) || (is_array($changesposone) && empty($changesposone))) {
            unset($this->changesposone);
        } else {
            $this->changesposone = $changesposone;
        }
        return $this;
    }
    /**
     * Add item to changesposone value
     * @throws \InvalidArgumentException
     * @param \StructType\Changesdataposone $item
     * @return \StructType\Changesdatapos
     */
    public function addToChangesposone(\StructType\Changesdataposone $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Changesdataposone) {
            throw new \InvalidArgumentException(sprintf('The changesposone property can only contain items of type \StructType\Changesdataposone, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->changesposone[] = $item;
        return $this;
    }
}
