<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changesrequest StructType
 * @subpackage Structs
 */
class Changesrequest extends AbstractStructBase
{
    /**
     * The ortid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $ortid;
    /**
     * The since
     * @var string
     */
    public $since;
    /**
     * Constructor method for changesrequest
     * @uses Changesrequest::setOrtid()
     * @uses Changesrequest::setSince()
     * @param int[] $ortid
     * @param string $since
     */
    public function __construct(array $ortid = array(), $since = null)
    {
        $this
            ->setOrtid($ortid)
            ->setSince($since);
    }
    /**
     * Get ortid value
     * @return int[]|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * This method is responsible for validating the values passed to the setOrtid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrtid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrtidForArrayConstraintsFromSetOrtid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $changesrequestOrtidItem) {
            // validation for constraint: itemType
            if (!(is_int($changesrequestOrtidItem) || ctype_digit($changesrequestOrtidItem))) {
                $invalidValues[] = is_object($changesrequestOrtidItem) ? get_class($changesrequestOrtidItem) : sprintf('%s(%s)', gettype($changesrequestOrtidItem), var_export($changesrequestOrtidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ortid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ortid value
     * @throws \InvalidArgumentException
     * @param int[] $ortid
     * @return \StructType\Changesrequest
     */
    public function setOrtid(array $ortid = array())
    {
        // validation for constraint: array
        if ('' !== ($ortidArrayErrorMessage = self::validateOrtidForArrayConstraintsFromSetOrtid($ortid))) {
            throw new \InvalidArgumentException($ortidArrayErrorMessage, __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Add item to ortid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Changesrequest
     */
    public function addToOrtid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The ortid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ortid[] = $item;
        return $this;
    }
    /**
     * Get since value
     * @return string|null
     */
    public function getSince()
    {
        return $this->since;
    }
    /**
     * Set since value
     * @param string $since
     * @return \StructType\Changesrequest
     */
    public function setSince($since = null)
    {
        // validation for constraint: string
        if (!is_null($since) && !is_string($since)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($since, true), gettype($since)), __LINE__);
        }
        $this->since = $since;
        return $this;
    }
}
