<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getKategorieInfo StructType
 * Meta information extracted from the WSDL
 * - type: tns:getKategorieInfo
 * @subpackage Structs
 */
class GetKategorieInfo extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Login
     */
    public $login;
    /**
     * The ortid
     * @var int
     */
    public $ortid;
    /**
     * The katid
     * @var int
     */
    public $katid;
    /**
     * The zeitpunkt
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var anySimpleType
     */
    public $zeitpunkt;
    /**
     * Constructor method for getKategorieInfo
     * @uses GetKategorieInfo::setLogin()
     * @uses GetKategorieInfo::setOrtid()
     * @uses GetKategorieInfo::setKatid()
     * @uses GetKategorieInfo::setZeitpunkt()
     * @param \StructType\Login $login
     * @param int $ortid
     * @param int $katid
     * @param anySimpleType $zeitpunkt
     */
    public function __construct(\StructType\Login $login = null, $ortid = null, $katid = null, anySimpleType $zeitpunkt = null)
    {
        $this
            ->setLogin($login)
            ->setOrtid($ortid)
            ->setKatid($katid)
            ->setZeitpunkt($zeitpunkt);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\GetKategorieInfo
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get ortid value
     * @return int|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * Set ortid value
     * @param int $ortid
     * @return \StructType\GetKategorieInfo
     */
    public function setOrtid($ortid = null)
    {
        // validation for constraint: int
        if (!is_null($ortid) && !(is_int($ortid) || ctype_digit($ortid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ortid, true), gettype($ortid)), __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Get katid value
     * @return int|null
     */
    public function getKatid()
    {
        return $this->katid;
    }
    /**
     * Set katid value
     * @param int $katid
     * @return \StructType\GetKategorieInfo
     */
    public function setKatid($katid = null)
    {
        // validation for constraint: int
        if (!is_null($katid) && !(is_int($katid) || ctype_digit($katid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($katid, true), gettype($katid)), __LINE__);
        }
        $this->katid = $katid;
        return $this;
    }
    /**
     * Get zeitpunkt value
     * @return anySimpleType|null
     */
    public function getZeitpunkt()
    {
        return $this->zeitpunkt;
    }
    /**
     * Set zeitpunkt value
     * @param anySimpleType $zeitpunkt
     * @return \StructType\GetKategorieInfo
     */
    public function setZeitpunkt(anySimpleType $zeitpunkt = null)
    {
        $this->zeitpunkt = $zeitpunkt;
        return $this;
    }
}
