<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ggvzdaten StructType
 * @subpackage Structs
 */
class Ggvzdaten extends AbstractStructBase
{
    /**
     * The hausmitkat
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Hausmitkat[]
     */
    public $hausmitkat;
    /**
     * Constructor method for ggvzdaten
     * @uses Ggvzdaten::setHausmitkat()
     * @param \StructType\Hausmitkat[] $hausmitkat
     */
    public function __construct(array $hausmitkat = array())
    {
        $this
            ->setHausmitkat($hausmitkat);
    }
    /**
     * Get hausmitkat value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Hausmitkat[]|null
     */
    public function getHausmitkat()
    {
        return isset($this->hausmitkat) ? $this->hausmitkat : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHausmitkat method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHausmitkat method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHausmitkatForArrayConstraintsFromSetHausmitkat(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ggvzdatenHausmitkatItem) {
            // validation for constraint: itemType
            if (!$ggvzdatenHausmitkatItem instanceof \StructType\Hausmitkat) {
                $invalidValues[] = is_object($ggvzdatenHausmitkatItem) ? get_class($ggvzdatenHausmitkatItem) : sprintf('%s(%s)', gettype($ggvzdatenHausmitkatItem), var_export($ggvzdatenHausmitkatItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hausmitkat property can only contain items of type \StructType\Hausmitkat, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hausmitkat value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Hausmitkat[] $hausmitkat
     * @return \StructType\Ggvzdaten
     */
    public function setHausmitkat(array $hausmitkat = array())
    {
        // validation for constraint: array
        if ('' !== ($hausmitkatArrayErrorMessage = self::validateHausmitkatForArrayConstraintsFromSetHausmitkat($hausmitkat))) {
            throw new \InvalidArgumentException($hausmitkatArrayErrorMessage, __LINE__);
        }
        if (is_null($hausmitkat) || (is_array($hausmitkat) && empty($hausmitkat))) {
            unset($this->hausmitkat);
        } else {
            $this->hausmitkat = $hausmitkat;
        }
        return $this;
    }
    /**
     * Add item to hausmitkat value
     * @throws \InvalidArgumentException
     * @param \StructType\Hausmitkat $item
     * @return \StructType\Ggvzdaten
     */
    public function addToHausmitkat(\StructType\Hausmitkat $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Hausmitkat) {
            throw new \InvalidArgumentException(sprintf('The hausmitkat property can only contain items of type \StructType\Hausmitkat, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hausmitkat[] = $item;
        return $this;
    }
}
