<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for katstaemme StructType
 * @subpackage Structs
 */
class Katstaemme extends AbstractStructBase
{
    /**
     * The stamm
     * @var string
     */
    public $stamm;
    /**
     * The katstamm
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Katstamm[]
     */
    public $katstamm;
    /**
     * Constructor method for katstaemme
     * @uses Katstaemme::setStamm()
     * @uses Katstaemme::setKatstamm()
     * @param string $stamm
     * @param \StructType\Katstamm[] $katstamm
     */
    public function __construct($stamm = null, array $katstamm = array())
    {
        $this
            ->setStamm($stamm)
            ->setKatstamm($katstamm);
    }
    /**
     * Get stamm value
     * @return string|null
     */
    public function getStamm()
    {
        return $this->stamm;
    }
    /**
     * Set stamm value
     * @param string $stamm
     * @return \StructType\Katstaemme
     */
    public function setStamm($stamm = null)
    {
        // validation for constraint: string
        if (!is_null($stamm) && !is_string($stamm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stamm, true), gettype($stamm)), __LINE__);
        }
        $this->stamm = $stamm;
        return $this;
    }
    /**
     * Get katstamm value
     * @return \StructType\Katstamm[]|null
     */
    public function getKatstamm()
    {
        return $this->katstamm;
    }
    /**
     * This method is responsible for validating the values passed to the setKatstamm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKatstamm method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKatstammForArrayConstraintsFromSetKatstamm(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $katstaemmeKatstammItem) {
            // validation for constraint: itemType
            if (!$katstaemmeKatstammItem instanceof \StructType\Katstamm) {
                $invalidValues[] = is_object($katstaemmeKatstammItem) ? get_class($katstaemmeKatstammItem) : sprintf('%s(%s)', gettype($katstaemmeKatstammItem), var_export($katstaemmeKatstammItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The katstamm property can only contain items of type \StructType\Katstamm, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set katstamm value
     * @throws \InvalidArgumentException
     * @param \StructType\Katstamm[] $katstamm
     * @return \StructType\Katstaemme
     */
    public function setKatstamm(array $katstamm = array())
    {
        // validation for constraint: array
        if ('' !== ($katstammArrayErrorMessage = self::validateKatstammForArrayConstraintsFromSetKatstamm($katstamm))) {
            throw new \InvalidArgumentException($katstammArrayErrorMessage, __LINE__);
        }
        $this->katstamm = $katstamm;
        return $this;
    }
    /**
     * Add item to katstamm value
     * @throws \InvalidArgumentException
     * @param \StructType\Katstamm $item
     * @return \StructType\Katstaemme
     */
    public function addToKatstamm(\StructType\Katstamm $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Katstamm) {
            throw new \InvalidArgumentException(sprintf('The katstamm property can only contain items of type \StructType\Katstamm, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->katstamm[] = $item;
        return $this;
    }
}
