<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kattext StructType
 * @subpackage Structs
 */
class Kattext extends AbstractStructBase
{
    /**
     * The ortid
     * @var int
     */
    public $ortid;
    /**
     * The katid
     * @var int
     */
    public $katid;
    /**
     * The gueltigab
     * @var int
     */
    public $gueltigab;
    /**
     * The gueltigbis
     * @var int
     */
    public $gueltigbis;
    /**
     * The art
     * @var int
     */
    public $art;
    /**
     * The lastchange
     * @var string
     */
    public $lastchange;
    /**
     * The status
     * @var int
     */
    public $status;
    /**
     * The sprache
     * @var string
     */
    public $sprache;
    /**
     * The text
     * @var string
     */
    public $text;
    /**
     * Constructor method for kattext
     * @uses Kattext::setOrtid()
     * @uses Kattext::setKatid()
     * @uses Kattext::setGueltigab()
     * @uses Kattext::setGueltigbis()
     * @uses Kattext::setArt()
     * @uses Kattext::setLastchange()
     * @uses Kattext::setStatus()
     * @uses Kattext::setSprache()
     * @uses Kattext::setText()
     * @param int $ortid
     * @param int $katid
     * @param int $gueltigab
     * @param int $gueltigbis
     * @param int $art
     * @param string $lastchange
     * @param int $status
     * @param string $sprache
     * @param string $text
     */
    public function __construct($ortid = null, $katid = null, $gueltigab = null, $gueltigbis = null, $art = null, $lastchange = null, $status = null, $sprache = null, $text = null)
    {
        $this
            ->setOrtid($ortid)
            ->setKatid($katid)
            ->setGueltigab($gueltigab)
            ->setGueltigbis($gueltigbis)
            ->setArt($art)
            ->setLastchange($lastchange)
            ->setStatus($status)
            ->setSprache($sprache)
            ->setText($text);
    }
    /**
     * Get ortid value
     * @return int|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * Set ortid value
     * @param int $ortid
     * @return \StructType\Kattext
     */
    public function setOrtid($ortid = null)
    {
        // validation for constraint: int
        if (!is_null($ortid) && !(is_int($ortid) || ctype_digit($ortid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ortid, true), gettype($ortid)), __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Get katid value
     * @return int|null
     */
    public function getKatid()
    {
        return $this->katid;
    }
    /**
     * Set katid value
     * @param int $katid
     * @return \StructType\Kattext
     */
    public function setKatid($katid = null)
    {
        // validation for constraint: int
        if (!is_null($katid) && !(is_int($katid) || ctype_digit($katid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($katid, true), gettype($katid)), __LINE__);
        }
        $this->katid = $katid;
        return $this;
    }
    /**
     * Get gueltigab value
     * @return int|null
     */
    public function getGueltigab()
    {
        return $this->gueltigab;
    }
    /**
     * Set gueltigab value
     * @param int $gueltigab
     * @return \StructType\Kattext
     */
    public function setGueltigab($gueltigab = null)
    {
        // validation for constraint: int
        if (!is_null($gueltigab) && !(is_int($gueltigab) || ctype_digit($gueltigab))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($gueltigab, true), gettype($gueltigab)), __LINE__);
        }
        $this->gueltigab = $gueltigab;
        return $this;
    }
    /**
     * Get gueltigbis value
     * @return int|null
     */
    public function getGueltigbis()
    {
        return $this->gueltigbis;
    }
    /**
     * Set gueltigbis value
     * @param int $gueltigbis
     * @return \StructType\Kattext
     */
    public function setGueltigbis($gueltigbis = null)
    {
        // validation for constraint: int
        if (!is_null($gueltigbis) && !(is_int($gueltigbis) || ctype_digit($gueltigbis))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($gueltigbis, true), gettype($gueltigbis)), __LINE__);
        }
        $this->gueltigbis = $gueltigbis;
        return $this;
    }
    /**
     * Get art value
     * @return int|null
     */
    public function getArt()
    {
        return $this->art;
    }
    /**
     * Set art value
     * @param int $art
     * @return \StructType\Kattext
     */
    public function setArt($art = null)
    {
        // validation for constraint: int
        if (!is_null($art) && !(is_int($art) || ctype_digit($art))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($art, true), gettype($art)), __LINE__);
        }
        $this->art = $art;
        return $this;
    }
    /**
     * Get lastchange value
     * @return string|null
     */
    public function getLastchange()
    {
        return $this->lastchange;
    }
    /**
     * Set lastchange value
     * @param string $lastchange
     * @return \StructType\Kattext
     */
    public function setLastchange($lastchange = null)
    {
        // validation for constraint: string
        if (!is_null($lastchange) && !is_string($lastchange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastchange, true), gettype($lastchange)), __LINE__);
        }
        $this->lastchange = $lastchange;
        return $this;
    }
    /**
     * Get status value
     * @return int|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param int $status
     * @return \StructType\Kattext
     */
    public function setStatus($status = null)
    {
        // validation for constraint: int
        if (!is_null($status) && !(is_int($status) || ctype_digit($status))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get sprache value
     * @return string|null
     */
    public function getSprache()
    {
        return $this->sprache;
    }
    /**
     * Set sprache value
     * @param string $sprache
     * @return \StructType\Kattext
     */
    public function setSprache($sprache = null)
    {
        // validation for constraint: string
        if (!is_null($sprache) && !is_string($sprache)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sprache, true), gettype($sprache)), __LINE__);
        }
        $this->sprache = $sprache;
        return $this;
    }
    /**
     * Get text value
     * @return string|null
     */
    public function getText()
    {
        return $this->text;
    }
    /**
     * Set text value
     * @param string $text
     * @return \StructType\Kattext
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        $this->text = $text;
        return $this;
    }
}
