<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for meldefristdata StructType
 * @subpackage Structs
 */
class Meldefristdata extends AbstractStructBase
{
    /**
     * The meldefristpos
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Meldefristpos[]
     */
    public $meldefristpos;
    /**
     * Constructor method for meldefristdata
     * @uses Meldefristdata::setMeldefristpos()
     * @param \StructType\Meldefristpos[] $meldefristpos
     */
    public function __construct(array $meldefristpos = array())
    {
        $this
            ->setMeldefristpos($meldefristpos);
    }
    /**
     * Get meldefristpos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Meldefristpos[]|null
     */
    public function getMeldefristpos()
    {
        return isset($this->meldefristpos) ? $this->meldefristpos : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMeldefristpos method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMeldefristpos method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMeldefristposForArrayConstraintsFromSetMeldefristpos(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $meldefristdataMeldefristposItem) {
            // validation for constraint: itemType
            if (!$meldefristdataMeldefristposItem instanceof \StructType\Meldefristpos) {
                $invalidValues[] = is_object($meldefristdataMeldefristposItem) ? get_class($meldefristdataMeldefristposItem) : sprintf('%s(%s)', gettype($meldefristdataMeldefristposItem), var_export($meldefristdataMeldefristposItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The meldefristpos property can only contain items of type \StructType\Meldefristpos, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set meldefristpos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Meldefristpos[] $meldefristpos
     * @return \StructType\Meldefristdata
     */
    public function setMeldefristpos(array $meldefristpos = array())
    {
        // validation for constraint: array
        if ('' !== ($meldefristposArrayErrorMessage = self::validateMeldefristposForArrayConstraintsFromSetMeldefristpos($meldefristpos))) {
            throw new \InvalidArgumentException($meldefristposArrayErrorMessage, __LINE__);
        }
        if (is_null($meldefristpos) || (is_array($meldefristpos) && empty($meldefristpos))) {
            unset($this->meldefristpos);
        } else {
            $this->meldefristpos = $meldefristpos;
        }
        return $this;
    }
    /**
     * Add item to meldefristpos value
     * @throws \InvalidArgumentException
     * @param \StructType\Meldefristpos $item
     * @return \StructType\Meldefristdata
     */
    public function addToMeldefristpos(\StructType\Meldefristpos $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Meldefristpos) {
            throw new \InvalidArgumentException(sprintf('The meldefristpos property can only contain items of type \StructType\Meldefristpos, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->meldefristpos[] = $item;
        return $this;
    }
}
