<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for meldefristrequest4php StructType
 * @subpackage Structs
 */
class Meldefristrequest4php extends AbstractStructBase
{
    /**
     * The ortid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $ortid;
    /**
     * The hausid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $hausid;
    /**
     * The since
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $since;
    /**
     * Constructor method for meldefristrequest4php
     * @uses Meldefristrequest4php::setOrtid()
     * @uses Meldefristrequest4php::setHausid()
     * @uses Meldefristrequest4php::setSince()
     * @param int[] $ortid
     * @param int[] $hausid
     * @param string $since
     */
    public function __construct(array $ortid = array(), array $hausid = array(), $since = null)
    {
        $this
            ->setOrtid($ortid)
            ->setHausid($hausid)
            ->setSince($since);
    }
    /**
     * Get ortid value
     * @return int[]|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * This method is responsible for validating the values passed to the setOrtid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrtid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrtidForArrayConstraintsFromSetOrtid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $meldefristrequest4phpOrtidItem) {
            // validation for constraint: itemType
            if (!(is_int($meldefristrequest4phpOrtidItem) || ctype_digit($meldefristrequest4phpOrtidItem))) {
                $invalidValues[] = is_object($meldefristrequest4phpOrtidItem) ? get_class($meldefristrequest4phpOrtidItem) : sprintf('%s(%s)', gettype($meldefristrequest4phpOrtidItem), var_export($meldefristrequest4phpOrtidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ortid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ortid value
     * @throws \InvalidArgumentException
     * @param int[] $ortid
     * @return \StructType\Meldefristrequest4php
     */
    public function setOrtid(array $ortid = array())
    {
        // validation for constraint: array
        if ('' !== ($ortidArrayErrorMessage = self::validateOrtidForArrayConstraintsFromSetOrtid($ortid))) {
            throw new \InvalidArgumentException($ortidArrayErrorMessage, __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Add item to ortid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Meldefristrequest4php
     */
    public function addToOrtid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The ortid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ortid[] = $item;
        return $this;
    }
    /**
     * Get hausid value
     * @return int[]|null
     */
    public function getHausid()
    {
        return $this->hausid;
    }
    /**
     * This method is responsible for validating the values passed to the setHausid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHausid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHausidForArrayConstraintsFromSetHausid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $meldefristrequest4phpHausidItem) {
            // validation for constraint: itemType
            if (!(is_int($meldefristrequest4phpHausidItem) || ctype_digit($meldefristrequest4phpHausidItem))) {
                $invalidValues[] = is_object($meldefristrequest4phpHausidItem) ? get_class($meldefristrequest4phpHausidItem) : sprintf('%s(%s)', gettype($meldefristrequest4phpHausidItem), var_export($meldefristrequest4phpHausidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hausid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hausid value
     * @throws \InvalidArgumentException
     * @param int[] $hausid
     * @return \StructType\Meldefristrequest4php
     */
    public function setHausid(array $hausid = array())
    {
        // validation for constraint: array
        if ('' !== ($hausidArrayErrorMessage = self::validateHausidForArrayConstraintsFromSetHausid($hausid))) {
            throw new \InvalidArgumentException($hausidArrayErrorMessage, __LINE__);
        }
        $this->hausid = $hausid;
        return $this;
    }
    /**
     * Add item to hausid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Meldefristrequest4php
     */
    public function addToHausid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The hausid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hausid[] = $item;
        return $this;
    }
    /**
     * Get since value
     * @return string|null
     */
    public function getSince()
    {
        return $this->since;
    }
    /**
     * Set since value
     * @param string $since
     * @return \StructType\Meldefristrequest4php
     */
    public function setSince($since = null)
    {
        // validation for constraint: string
        if (!is_null($since) && !is_string($since)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($since, true), gettype($since)), __LINE__);
        }
        $this->since = $since;
        return $this;
    }
}
