<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for orte StructType
 * @subpackage Structs
 */
class Orte extends AbstractStructBase
{
    /**
     * The ort
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Ort[]
     */
    public $ort;
    /**
     * Constructor method for orte
     * @uses Orte::setOrt()
     * @param \StructType\Ort[] $ort
     */
    public function __construct(array $ort = array())
    {
        $this
            ->setOrt($ort);
    }
    /**
     * Get ort value
     * @return \StructType\Ort[]|null
     */
    public function getOrt()
    {
        return $this->ort;
    }
    /**
     * This method is responsible for validating the values passed to the setOrt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrtForArrayConstraintsFromSetOrt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $orteOrtItem) {
            // validation for constraint: itemType
            if (!$orteOrtItem instanceof \StructType\Ort) {
                $invalidValues[] = is_object($orteOrtItem) ? get_class($orteOrtItem) : sprintf('%s(%s)', gettype($orteOrtItem), var_export($orteOrtItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ort property can only contain items of type \StructType\Ort, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ort value
     * @throws \InvalidArgumentException
     * @param \StructType\Ort[] $ort
     * @return \StructType\Orte
     */
    public function setOrt(array $ort = array())
    {
        // validation for constraint: array
        if ('' !== ($ortArrayErrorMessage = self::validateOrtForArrayConstraintsFromSetOrt($ort))) {
            throw new \InvalidArgumentException($ortArrayErrorMessage, __LINE__);
        }
        $this->ort = $ort;
        return $this;
    }
    /**
     * Add item to ort value
     * @throws \InvalidArgumentException
     * @param \StructType\Ort $item
     * @return \StructType\Orte
     */
    public function addToOrt(\StructType\Ort $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Ort) {
            throw new \InvalidArgumentException(sprintf('The ort property can only contain items of type \StructType\Ort, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ort[] = $item;
        return $this;
    }
}
