<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pauschalen StructType
 * @subpackage Structs
 */
class Pauschalen extends AbstractStructBase
{
    /**
     * The pauschale
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Pauschale[]
     */
    public $pauschale;
    /**
     * Constructor method for pauschalen
     * @uses Pauschalen::setPauschale()
     * @param \StructType\Pauschale[] $pauschale
     */
    public function __construct(array $pauschale = array())
    {
        $this
            ->setPauschale($pauschale);
    }
    /**
     * Get pauschale value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Pauschale[]|null
     */
    public function getPauschale()
    {
        return isset($this->pauschale) ? $this->pauschale : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPauschale method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPauschale method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePauschaleForArrayConstraintsFromSetPauschale(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pauschalenPauschaleItem) {
            // validation for constraint: itemType
            if (!$pauschalenPauschaleItem instanceof \StructType\Pauschale) {
                $invalidValues[] = is_object($pauschalenPauschaleItem) ? get_class($pauschalenPauschaleItem) : sprintf('%s(%s)', gettype($pauschalenPauschaleItem), var_export($pauschalenPauschaleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The pauschale property can only contain items of type \StructType\Pauschale, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set pauschale value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Pauschale[] $pauschale
     * @return \StructType\Pauschalen
     */
    public function setPauschale(array $pauschale = array())
    {
        // validation for constraint: array
        if ('' !== ($pauschaleArrayErrorMessage = self::validatePauschaleForArrayConstraintsFromSetPauschale($pauschale))) {
            throw new \InvalidArgumentException($pauschaleArrayErrorMessage, __LINE__);
        }
        if (is_null($pauschale) || (is_array($pauschale) && empty($pauschale))) {
            unset($this->pauschale);
        } else {
            $this->pauschale = $pauschale;
        }
        return $this;
    }
    /**
     * Add item to pauschale value
     * @throws \InvalidArgumentException
     * @param \StructType\Pauschale $item
     * @return \StructType\Pauschalen
     */
    public function addToPauschale(\StructType\Pauschale $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Pauschale) {
            throw new \InvalidArgumentException(sprintf('The pauschale property can only contain items of type \StructType\Pauschale, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->pauschale[] = $item;
        return $this;
    }
}
