<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pauschalenrequest StructType
 * @subpackage Structs
 */
class Pauschalenrequest extends AbstractStructBase
{
    /**
     * The useversion
     * @var int
     */
    public $useversion;
    /**
     * The ortids
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $ortids;
    /**
     * The hausids
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $hausids;
    /**
     * The katids
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $katids;
    /**
     * The pauids
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $pauids;
    /**
     * The von
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $von;
    /**
     * The bis
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $bis;
    /**
     * The naechte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $naechte;
    /**
     * The sprache
     * @var string
     */
    public $sprache;
    /**
     * The channelid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $channelid;
    /**
     * Constructor method for pauschalenrequest
     * @uses Pauschalenrequest::setUseversion()
     * @uses Pauschalenrequest::setOrtids()
     * @uses Pauschalenrequest::setHausids()
     * @uses Pauschalenrequest::setKatids()
     * @uses Pauschalenrequest::setPauids()
     * @uses Pauschalenrequest::setVon()
     * @uses Pauschalenrequest::setBis()
     * @uses Pauschalenrequest::setNaechte()
     * @uses Pauschalenrequest::setSprache()
     * @uses Pauschalenrequest::setChannelid()
     * @param int $useversion
     * @param int[] $ortids
     * @param int[] $hausids
     * @param int[] $katids
     * @param int[] $pauids
     * @param string $von
     * @param string $bis
     * @param int $naechte
     * @param string $sprache
     * @param int $channelid
     */
    public function __construct($useversion = null, array $ortids = array(), array $hausids = array(), array $katids = array(), array $pauids = array(), $von = null, $bis = null, $naechte = null, $sprache = null, $channelid = null)
    {
        $this
            ->setUseversion($useversion)
            ->setOrtids($ortids)
            ->setHausids($hausids)
            ->setKatids($katids)
            ->setPauids($pauids)
            ->setVon($von)
            ->setBis($bis)
            ->setNaechte($naechte)
            ->setSprache($sprache)
            ->setChannelid($channelid);
    }
    /**
     * Get useversion value
     * @return int|null
     */
    public function getUseversion()
    {
        return $this->useversion;
    }
    /**
     * Set useversion value
     * @param int $useversion
     * @return \StructType\Pauschalenrequest
     */
    public function setUseversion($useversion = null)
    {
        // validation for constraint: int
        if (!is_null($useversion) && !(is_int($useversion) || ctype_digit($useversion))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($useversion, true), gettype($useversion)), __LINE__);
        }
        $this->useversion = $useversion;
        return $this;
    }
    /**
     * Get ortids value
     * @return int[]|null
     */
    public function getOrtids()
    {
        return $this->ortids;
    }
    /**
     * This method is responsible for validating the values passed to the setOrtids method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrtids method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrtidsForArrayConstraintsFromSetOrtids(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pauschalenrequestOrtidsItem) {
            // validation for constraint: itemType
            if (!(is_int($pauschalenrequestOrtidsItem) || ctype_digit($pauschalenrequestOrtidsItem))) {
                $invalidValues[] = is_object($pauschalenrequestOrtidsItem) ? get_class($pauschalenrequestOrtidsItem) : sprintf('%s(%s)', gettype($pauschalenrequestOrtidsItem), var_export($pauschalenrequestOrtidsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ortids property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ortids value
     * @throws \InvalidArgumentException
     * @param int[] $ortids
     * @return \StructType\Pauschalenrequest
     */
    public function setOrtids(array $ortids = array())
    {
        // validation for constraint: array
        if ('' !== ($ortidsArrayErrorMessage = self::validateOrtidsForArrayConstraintsFromSetOrtids($ortids))) {
            throw new \InvalidArgumentException($ortidsArrayErrorMessage, __LINE__);
        }
        $this->ortids = $ortids;
        return $this;
    }
    /**
     * Add item to ortids value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Pauschalenrequest
     */
    public function addToOrtids($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The ortids property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ortids[] = $item;
        return $this;
    }
    /**
     * Get hausids value
     * @return int[]|null
     */
    public function getHausids()
    {
        return $this->hausids;
    }
    /**
     * This method is responsible for validating the values passed to the setHausids method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHausids method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHausidsForArrayConstraintsFromSetHausids(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pauschalenrequestHausidsItem) {
            // validation for constraint: itemType
            if (!(is_int($pauschalenrequestHausidsItem) || ctype_digit($pauschalenrequestHausidsItem))) {
                $invalidValues[] = is_object($pauschalenrequestHausidsItem) ? get_class($pauschalenrequestHausidsItem) : sprintf('%s(%s)', gettype($pauschalenrequestHausidsItem), var_export($pauschalenrequestHausidsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hausids property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hausids value
     * @throws \InvalidArgumentException
     * @param int[] $hausids
     * @return \StructType\Pauschalenrequest
     */
    public function setHausids(array $hausids = array())
    {
        // validation for constraint: array
        if ('' !== ($hausidsArrayErrorMessage = self::validateHausidsForArrayConstraintsFromSetHausids($hausids))) {
            throw new \InvalidArgumentException($hausidsArrayErrorMessage, __LINE__);
        }
        $this->hausids = $hausids;
        return $this;
    }
    /**
     * Add item to hausids value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Pauschalenrequest
     */
    public function addToHausids($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The hausids property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hausids[] = $item;
        return $this;
    }
    /**
     * Get katids value
     * @return int[]|null
     */
    public function getKatids()
    {
        return $this->katids;
    }
    /**
     * This method is responsible for validating the values passed to the setKatids method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKatids method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKatidsForArrayConstraintsFromSetKatids(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pauschalenrequestKatidsItem) {
            // validation for constraint: itemType
            if (!(is_int($pauschalenrequestKatidsItem) || ctype_digit($pauschalenrequestKatidsItem))) {
                $invalidValues[] = is_object($pauschalenrequestKatidsItem) ? get_class($pauschalenrequestKatidsItem) : sprintf('%s(%s)', gettype($pauschalenrequestKatidsItem), var_export($pauschalenrequestKatidsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The katids property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set katids value
     * @throws \InvalidArgumentException
     * @param int[] $katids
     * @return \StructType\Pauschalenrequest
     */
    public function setKatids(array $katids = array())
    {
        // validation for constraint: array
        if ('' !== ($katidsArrayErrorMessage = self::validateKatidsForArrayConstraintsFromSetKatids($katids))) {
            throw new \InvalidArgumentException($katidsArrayErrorMessage, __LINE__);
        }
        $this->katids = $katids;
        return $this;
    }
    /**
     * Add item to katids value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Pauschalenrequest
     */
    public function addToKatids($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The katids property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->katids[] = $item;
        return $this;
    }
    /**
     * Get pauids value
     * @return int[]|null
     */
    public function getPauids()
    {
        return $this->pauids;
    }
    /**
     * This method is responsible for validating the values passed to the setPauids method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPauids method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePauidsForArrayConstraintsFromSetPauids(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pauschalenrequestPauidsItem) {
            // validation for constraint: itemType
            if (!(is_int($pauschalenrequestPauidsItem) || ctype_digit($pauschalenrequestPauidsItem))) {
                $invalidValues[] = is_object($pauschalenrequestPauidsItem) ? get_class($pauschalenrequestPauidsItem) : sprintf('%s(%s)', gettype($pauschalenrequestPauidsItem), var_export($pauschalenrequestPauidsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The pauids property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set pauids value
     * @throws \InvalidArgumentException
     * @param int[] $pauids
     * @return \StructType\Pauschalenrequest
     */
    public function setPauids(array $pauids = array())
    {
        // validation for constraint: array
        if ('' !== ($pauidsArrayErrorMessage = self::validatePauidsForArrayConstraintsFromSetPauids($pauids))) {
            throw new \InvalidArgumentException($pauidsArrayErrorMessage, __LINE__);
        }
        $this->pauids = $pauids;
        return $this;
    }
    /**
     * Add item to pauids value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Pauschalenrequest
     */
    public function addToPauids($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The pauids property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->pauids[] = $item;
        return $this;
    }
    /**
     * Get von value
     * @return string|null
     */
    public function getVon()
    {
        return $this->von;
    }
    /**
     * Set von value
     * @param string $von
     * @return \StructType\Pauschalenrequest
     */
    public function setVon($von = null)
    {
        // validation for constraint: string
        if (!is_null($von) && !is_string($von)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($von, true), gettype($von)), __LINE__);
        }
        $this->von = $von;
        return $this;
    }
    /**
     * Get bis value
     * @return string|null
     */
    public function getBis()
    {
        return $this->bis;
    }
    /**
     * Set bis value
     * @param string $bis
     * @return \StructType\Pauschalenrequest
     */
    public function setBis($bis = null)
    {
        // validation for constraint: string
        if (!is_null($bis) && !is_string($bis)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bis, true), gettype($bis)), __LINE__);
        }
        $this->bis = $bis;
        return $this;
    }
    /**
     * Get naechte value
     * @return int|null
     */
    public function getNaechte()
    {
        return $this->naechte;
    }
    /**
     * Set naechte value
     * @param int $naechte
     * @return \StructType\Pauschalenrequest
     */
    public function setNaechte($naechte = null)
    {
        // validation for constraint: int
        if (!is_null($naechte) && !(is_int($naechte) || ctype_digit($naechte))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($naechte, true), gettype($naechte)), __LINE__);
        }
        $this->naechte = $naechte;
        return $this;
    }
    /**
     * Get sprache value
     * @return string|null
     */
    public function getSprache()
    {
        return $this->sprache;
    }
    /**
     * Set sprache value
     * @param string $sprache
     * @return \StructType\Pauschalenrequest
     */
    public function setSprache($sprache = null)
    {
        // validation for constraint: string
        if (!is_null($sprache) && !is_string($sprache)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sprache, true), gettype($sprache)), __LINE__);
        }
        $this->sprache = $sprache;
        return $this;
    }
    /**
     * Get channelid value
     * @return int|null
     */
    public function getChannelid()
    {
        return $this->channelid;
    }
    /**
     * Set channelid value
     * @param int $channelid
     * @return \StructType\Pauschalenrequest
     */
    public function setChannelid($channelid = null)
    {
        // validation for constraint: int
        if (!is_null($channelid) && !(is_int($channelid) || ctype_digit($channelid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($channelid, true), gettype($channelid)), __LINE__);
        }
        $this->channelid = $channelid;
        return $this;
    }
}
