<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tarifrequest StructType
 * @subpackage Structs
 */
class Tarifrequest extends AbstractStructBase
{
    /**
     * The ortid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $ortid;
    /**
     * The hausid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $hausid;
    /**
     * The tarif
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $tarif;
    /**
     * The since
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $since;
    /**
     * Constructor method for tarifrequest
     * @uses Tarifrequest::setOrtid()
     * @uses Tarifrequest::setHausid()
     * @uses Tarifrequest::setTarif()
     * @uses Tarifrequest::setSince()
     * @param int[] $ortid
     * @param int[] $hausid
     * @param string[] $tarif
     * @param string $since
     */
    public function __construct(array $ortid = array(), array $hausid = array(), array $tarif = array(), $since = null)
    {
        $this
            ->setOrtid($ortid)
            ->setHausid($hausid)
            ->setTarif($tarif)
            ->setSince($since);
    }
    /**
     * Get ortid value
     * @return int[]|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * This method is responsible for validating the values passed to the setOrtid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrtid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrtidForArrayConstraintsFromSetOrtid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tarifrequestOrtidItem) {
            // validation for constraint: itemType
            if (!(is_int($tarifrequestOrtidItem) || ctype_digit($tarifrequestOrtidItem))) {
                $invalidValues[] = is_object($tarifrequestOrtidItem) ? get_class($tarifrequestOrtidItem) : sprintf('%s(%s)', gettype($tarifrequestOrtidItem), var_export($tarifrequestOrtidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ortid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ortid value
     * @throws \InvalidArgumentException
     * @param int[] $ortid
     * @return \StructType\Tarifrequest
     */
    public function setOrtid(array $ortid = array())
    {
        // validation for constraint: array
        if ('' !== ($ortidArrayErrorMessage = self::validateOrtidForArrayConstraintsFromSetOrtid($ortid))) {
            throw new \InvalidArgumentException($ortidArrayErrorMessage, __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Add item to ortid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tarifrequest
     */
    public function addToOrtid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The ortid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ortid[] = $item;
        return $this;
    }
    /**
     * Get hausid value
     * @return int[]|null
     */
    public function getHausid()
    {
        return $this->hausid;
    }
    /**
     * This method is responsible for validating the values passed to the setHausid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHausid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHausidForArrayConstraintsFromSetHausid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tarifrequestHausidItem) {
            // validation for constraint: itemType
            if (!(is_int($tarifrequestHausidItem) || ctype_digit($tarifrequestHausidItem))) {
                $invalidValues[] = is_object($tarifrequestHausidItem) ? get_class($tarifrequestHausidItem) : sprintf('%s(%s)', gettype($tarifrequestHausidItem), var_export($tarifrequestHausidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hausid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hausid value
     * @throws \InvalidArgumentException
     * @param int[] $hausid
     * @return \StructType\Tarifrequest
     */
    public function setHausid(array $hausid = array())
    {
        // validation for constraint: array
        if ('' !== ($hausidArrayErrorMessage = self::validateHausidForArrayConstraintsFromSetHausid($hausid))) {
            throw new \InvalidArgumentException($hausidArrayErrorMessage, __LINE__);
        }
        $this->hausid = $hausid;
        return $this;
    }
    /**
     * Add item to hausid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tarifrequest
     */
    public function addToHausid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The hausid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hausid[] = $item;
        return $this;
    }
    /**
     * Get tarif value
     * @return string[]|null
     */
    public function getTarif()
    {
        return $this->tarif;
    }
    /**
     * This method is responsible for validating the values passed to the setTarif method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTarif method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTarifForArrayConstraintsFromSetTarif(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tarifrequestTarifItem) {
            // validation for constraint: itemType
            if (!is_string($tarifrequestTarifItem)) {
                $invalidValues[] = is_object($tarifrequestTarifItem) ? get_class($tarifrequestTarifItem) : sprintf('%s(%s)', gettype($tarifrequestTarifItem), var_export($tarifrequestTarifItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The tarif property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set tarif value
     * @throws \InvalidArgumentException
     * @param string[] $tarif
     * @return \StructType\Tarifrequest
     */
    public function setTarif(array $tarif = array())
    {
        // validation for constraint: array
        if ('' !== ($tarifArrayErrorMessage = self::validateTarifForArrayConstraintsFromSetTarif($tarif))) {
            throw new \InvalidArgumentException($tarifArrayErrorMessage, __LINE__);
        }
        $this->tarif = $tarif;
        return $this;
    }
    /**
     * Add item to tarif value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\Tarifrequest
     */
    public function addToTarif($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The tarif property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->tarif[] = $item;
        return $this;
    }
    /**
     * Get since value
     * @return string|null
     */
    public function getSince()
    {
        return $this->since;
    }
    /**
     * Set since value
     * @param string $since
     * @return \StructType\Tarifrequest
     */
    public function setSince($since = null)
    {
        // validation for constraint: string
        if (!is_null($since) && !is_string($since)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($since, true), gettype($since)), __LINE__);
        }
        $this->since = $since;
        return $this;
    }
}
