<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tipauschaledefiniton StructType
 * @subpackage Structs
 */
class Tipauschaledefiniton extends AbstractStructBase
{
    /**
     * The pauid
     * @var int
     */
    public $pauid;
    /**
     * The ortid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $ortid;
    /**
     * The bezirkid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $bezirkid;
    /**
     * The hkatid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $hkatid;
    /**
     * The hausid
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $hausid;
    /**
     * The minsterne
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $minsterne;
    /**
     * The anztage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var int[]
     */
    public $anztage;
    /**
     * Constructor method for tipauschaledefiniton
     * @uses Tipauschaledefiniton::setPauid()
     * @uses Tipauschaledefiniton::setOrtid()
     * @uses Tipauschaledefiniton::setBezirkid()
     * @uses Tipauschaledefiniton::setHkatid()
     * @uses Tipauschaledefiniton::setHausid()
     * @uses Tipauschaledefiniton::setMinsterne()
     * @uses Tipauschaledefiniton::setAnztage()
     * @param int $pauid
     * @param int[] $ortid
     * @param int[] $bezirkid
     * @param int[] $hkatid
     * @param int[] $hausid
     * @param int $minsterne
     * @param int[] $anztage
     */
    public function __construct($pauid = null, array $ortid = array(), array $bezirkid = array(), array $hkatid = array(), array $hausid = array(), $minsterne = null, array $anztage = array())
    {
        $this
            ->setPauid($pauid)
            ->setOrtid($ortid)
            ->setBezirkid($bezirkid)
            ->setHkatid($hkatid)
            ->setHausid($hausid)
            ->setMinsterne($minsterne)
            ->setAnztage($anztage);
    }
    /**
     * Get pauid value
     * @return int|null
     */
    public function getPauid()
    {
        return $this->pauid;
    }
    /**
     * Set pauid value
     * @param int $pauid
     * @return \StructType\Tipauschaledefiniton
     */
    public function setPauid($pauid = null)
    {
        // validation for constraint: int
        if (!is_null($pauid) && !(is_int($pauid) || ctype_digit($pauid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pauid, true), gettype($pauid)), __LINE__);
        }
        $this->pauid = $pauid;
        return $this;
    }
    /**
     * Get ortid value
     * @return int[]|null
     */
    public function getOrtid()
    {
        return $this->ortid;
    }
    /**
     * This method is responsible for validating the values passed to the setOrtid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrtid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrtidForArrayConstraintsFromSetOrtid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tipauschaledefinitonOrtidItem) {
            // validation for constraint: itemType
            if (!(is_int($tipauschaledefinitonOrtidItem) || ctype_digit($tipauschaledefinitonOrtidItem))) {
                $invalidValues[] = is_object($tipauschaledefinitonOrtidItem) ? get_class($tipauschaledefinitonOrtidItem) : sprintf('%s(%s)', gettype($tipauschaledefinitonOrtidItem), var_export($tipauschaledefinitonOrtidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ortid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ortid value
     * @throws \InvalidArgumentException
     * @param int[] $ortid
     * @return \StructType\Tipauschaledefiniton
     */
    public function setOrtid(array $ortid = array())
    {
        // validation for constraint: array
        if ('' !== ($ortidArrayErrorMessage = self::validateOrtidForArrayConstraintsFromSetOrtid($ortid))) {
            throw new \InvalidArgumentException($ortidArrayErrorMessage, __LINE__);
        }
        $this->ortid = $ortid;
        return $this;
    }
    /**
     * Add item to ortid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tipauschaledefiniton
     */
    public function addToOrtid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The ortid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ortid[] = $item;
        return $this;
    }
    /**
     * Get bezirkid value
     * @return int[]|null
     */
    public function getBezirkid()
    {
        return $this->bezirkid;
    }
    /**
     * This method is responsible for validating the values passed to the setBezirkid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBezirkid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBezirkidForArrayConstraintsFromSetBezirkid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tipauschaledefinitonBezirkidItem) {
            // validation for constraint: itemType
            if (!(is_int($tipauschaledefinitonBezirkidItem) || ctype_digit($tipauschaledefinitonBezirkidItem))) {
                $invalidValues[] = is_object($tipauschaledefinitonBezirkidItem) ? get_class($tipauschaledefinitonBezirkidItem) : sprintf('%s(%s)', gettype($tipauschaledefinitonBezirkidItem), var_export($tipauschaledefinitonBezirkidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bezirkid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bezirkid value
     * @throws \InvalidArgumentException
     * @param int[] $bezirkid
     * @return \StructType\Tipauschaledefiniton
     */
    public function setBezirkid(array $bezirkid = array())
    {
        // validation for constraint: array
        if ('' !== ($bezirkidArrayErrorMessage = self::validateBezirkidForArrayConstraintsFromSetBezirkid($bezirkid))) {
            throw new \InvalidArgumentException($bezirkidArrayErrorMessage, __LINE__);
        }
        $this->bezirkid = $bezirkid;
        return $this;
    }
    /**
     * Add item to bezirkid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tipauschaledefiniton
     */
    public function addToBezirkid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The bezirkid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bezirkid[] = $item;
        return $this;
    }
    /**
     * Get hkatid value
     * @return int[]|null
     */
    public function getHkatid()
    {
        return $this->hkatid;
    }
    /**
     * This method is responsible for validating the values passed to the setHkatid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHkatid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHkatidForArrayConstraintsFromSetHkatid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tipauschaledefinitonHkatidItem) {
            // validation for constraint: itemType
            if (!(is_int($tipauschaledefinitonHkatidItem) || ctype_digit($tipauschaledefinitonHkatidItem))) {
                $invalidValues[] = is_object($tipauschaledefinitonHkatidItem) ? get_class($tipauschaledefinitonHkatidItem) : sprintf('%s(%s)', gettype($tipauschaledefinitonHkatidItem), var_export($tipauschaledefinitonHkatidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hkatid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hkatid value
     * @throws \InvalidArgumentException
     * @param int[] $hkatid
     * @return \StructType\Tipauschaledefiniton
     */
    public function setHkatid(array $hkatid = array())
    {
        // validation for constraint: array
        if ('' !== ($hkatidArrayErrorMessage = self::validateHkatidForArrayConstraintsFromSetHkatid($hkatid))) {
            throw new \InvalidArgumentException($hkatidArrayErrorMessage, __LINE__);
        }
        $this->hkatid = $hkatid;
        return $this;
    }
    /**
     * Add item to hkatid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tipauschaledefiniton
     */
    public function addToHkatid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The hkatid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hkatid[] = $item;
        return $this;
    }
    /**
     * Get hausid value
     * @return int[]|null
     */
    public function getHausid()
    {
        return $this->hausid;
    }
    /**
     * This method is responsible for validating the values passed to the setHausid method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHausid method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHausidForArrayConstraintsFromSetHausid(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tipauschaledefinitonHausidItem) {
            // validation for constraint: itemType
            if (!(is_int($tipauschaledefinitonHausidItem) || ctype_digit($tipauschaledefinitonHausidItem))) {
                $invalidValues[] = is_object($tipauschaledefinitonHausidItem) ? get_class($tipauschaledefinitonHausidItem) : sprintf('%s(%s)', gettype($tipauschaledefinitonHausidItem), var_export($tipauschaledefinitonHausidItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The hausid property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set hausid value
     * @throws \InvalidArgumentException
     * @param int[] $hausid
     * @return \StructType\Tipauschaledefiniton
     */
    public function setHausid(array $hausid = array())
    {
        // validation for constraint: array
        if ('' !== ($hausidArrayErrorMessage = self::validateHausidForArrayConstraintsFromSetHausid($hausid))) {
            throw new \InvalidArgumentException($hausidArrayErrorMessage, __LINE__);
        }
        $this->hausid = $hausid;
        return $this;
    }
    /**
     * Add item to hausid value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tipauschaledefiniton
     */
    public function addToHausid($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The hausid property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->hausid[] = $item;
        return $this;
    }
    /**
     * Get minsterne value
     * @return int|null
     */
    public function getMinsterne()
    {
        return $this->minsterne;
    }
    /**
     * Set minsterne value
     * @param int $minsterne
     * @return \StructType\Tipauschaledefiniton
     */
    public function setMinsterne($minsterne = null)
    {
        // validation for constraint: int
        if (!is_null($minsterne) && !(is_int($minsterne) || ctype_digit($minsterne))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($minsterne, true), gettype($minsterne)), __LINE__);
        }
        $this->minsterne = $minsterne;
        return $this;
    }
    /**
     * Get anztage value
     * @return int[]|null
     */
    public function getAnztage()
    {
        return $this->anztage;
    }
    /**
     * This method is responsible for validating the values passed to the setAnztage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnztage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnztageForArrayConstraintsFromSetAnztage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tipauschaledefinitonAnztageItem) {
            // validation for constraint: itemType
            if (!(is_int($tipauschaledefinitonAnztageItem) || ctype_digit($tipauschaledefinitonAnztageItem))) {
                $invalidValues[] = is_object($tipauschaledefinitonAnztageItem) ? get_class($tipauschaledefinitonAnztageItem) : sprintf('%s(%s)', gettype($tipauschaledefinitonAnztageItem), var_export($tipauschaledefinitonAnztageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The anztage property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set anztage value
     * @throws \InvalidArgumentException
     * @param int[] $anztage
     * @return \StructType\Tipauschaledefiniton
     */
    public function setAnztage(array $anztage = array())
    {
        // validation for constraint: array
        if ('' !== ($anztageArrayErrorMessage = self::validateAnztageForArrayConstraintsFromSetAnztage($anztage))) {
            throw new \InvalidArgumentException($anztageArrayErrorMessage, __LINE__);
        }
        $this->anztage = $anztage;
        return $this;
    }
    /**
     * Add item to anztage value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\Tipauschaledefiniton
     */
    public function addToAnztage($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The anztage property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->anztage[] = $item;
        return $this;
    }
}
