<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for xferrequest StructType
 * @subpackage Structs
 */
class Xferrequest extends AbstractStructBase
{
    /**
     * The von
     * @var string
     */
    public $von;
    /**
     * The bis
     * @var string
     */
    public $bis;
    /**
     * The sprache
     * @var string
     */
    public $sprache;
    /**
     * The channelid
     * @var int
     */
    public $channelid;
    /**
     * The searchresultpos
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Searchresultpos[]
     */
    public $searchresultpos;
    /**
     * Constructor method for xferrequest
     * @uses Xferrequest::setVon()
     * @uses Xferrequest::setBis()
     * @uses Xferrequest::setSprache()
     * @uses Xferrequest::setChannelid()
     * @uses Xferrequest::setSearchresultpos()
     * @param string $von
     * @param string $bis
     * @param string $sprache
     * @param int $channelid
     * @param \StructType\Searchresultpos[] $searchresultpos
     */
    public function __construct($von = null, $bis = null, $sprache = null, $channelid = null, array $searchresultpos = array())
    {
        $this
            ->setVon($von)
            ->setBis($bis)
            ->setSprache($sprache)
            ->setChannelid($channelid)
            ->setSearchresultpos($searchresultpos);
    }
    /**
     * Get von value
     * @return string|null
     */
    public function getVon()
    {
        return $this->von;
    }
    /**
     * Set von value
     * @param string $von
     * @return \StructType\Xferrequest
     */
    public function setVon($von = null)
    {
        // validation for constraint: string
        if (!is_null($von) && !is_string($von)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($von, true), gettype($von)), __LINE__);
        }
        $this->von = $von;
        return $this;
    }
    /**
     * Get bis value
     * @return string|null
     */
    public function getBis()
    {
        return $this->bis;
    }
    /**
     * Set bis value
     * @param string $bis
     * @return \StructType\Xferrequest
     */
    public function setBis($bis = null)
    {
        // validation for constraint: string
        if (!is_null($bis) && !is_string($bis)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bis, true), gettype($bis)), __LINE__);
        }
        $this->bis = $bis;
        return $this;
    }
    /**
     * Get sprache value
     * @return string|null
     */
    public function getSprache()
    {
        return $this->sprache;
    }
    /**
     * Set sprache value
     * @param string $sprache
     * @return \StructType\Xferrequest
     */
    public function setSprache($sprache = null)
    {
        // validation for constraint: string
        if (!is_null($sprache) && !is_string($sprache)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sprache, true), gettype($sprache)), __LINE__);
        }
        $this->sprache = $sprache;
        return $this;
    }
    /**
     * Get channelid value
     * @return int|null
     */
    public function getChannelid()
    {
        return $this->channelid;
    }
    /**
     * Set channelid value
     * @param int $channelid
     * @return \StructType\Xferrequest
     */
    public function setChannelid($channelid = null)
    {
        // validation for constraint: int
        if (!is_null($channelid) && !(is_int($channelid) || ctype_digit($channelid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($channelid, true), gettype($channelid)), __LINE__);
        }
        $this->channelid = $channelid;
        return $this;
    }
    /**
     * Get searchresultpos value
     * @return \StructType\Searchresultpos[]|null
     */
    public function getSearchresultpos()
    {
        return $this->searchresultpos;
    }
    /**
     * This method is responsible for validating the values passed to the setSearchresultpos method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSearchresultpos method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSearchresultposForArrayConstraintsFromSetSearchresultpos(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xferrequestSearchresultposItem) {
            // validation for constraint: itemType
            if (!$xferrequestSearchresultposItem instanceof \StructType\Searchresultpos) {
                $invalidValues[] = is_object($xferrequestSearchresultposItem) ? get_class($xferrequestSearchresultposItem) : sprintf('%s(%s)', gettype($xferrequestSearchresultposItem), var_export($xferrequestSearchresultposItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The searchresultpos property can only contain items of type \StructType\Searchresultpos, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set searchresultpos value
     * @throws \InvalidArgumentException
     * @param \StructType\Searchresultpos[] $searchresultpos
     * @return \StructType\Xferrequest
     */
    public function setSearchresultpos(array $searchresultpos = array())
    {
        // validation for constraint: array
        if ('' !== ($searchresultposArrayErrorMessage = self::validateSearchresultposForArrayConstraintsFromSetSearchresultpos($searchresultpos))) {
            throw new \InvalidArgumentException($searchresultposArrayErrorMessage, __LINE__);
        }
        $this->searchresultpos = $searchresultpos;
        return $this;
    }
    /**
     * Add item to searchresultpos value
     * @throws \InvalidArgumentException
     * @param \StructType\Searchresultpos $item
     * @return \StructType\Xferrequest
     */
    public function addToSearchresultpos(\StructType\Searchresultpos $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Searchresultpos) {
            throw new \InvalidArgumentException(sprintf('The searchresultpos property can only contain items of type \StructType\Searchresultpos, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->searchresultpos[] = $item;
        return $this;
    }
}
